1. 程式人生 > >leetcode-1. Two Sum-簡單的演算法題,面試見到了嗎?

leetcode-1. Two Sum-簡單的演算法題,面試見到了嗎?

leetcode第一道題,很簡單大部分人應該能想到用map,而我只想到暴力,思維確實得到了鍛鍊。
Question: Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution.

Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].

descript:給定一個數組,和目標值,求數組裡兩個數的和等於目標值的下標,數組裡數不重複。

菜鳥解法 (Brute Force)

public int[] twoSum(int[] nums, int target) {
    for (int i = 0; i < nums.length; i++) {
        for (int j = i + 1; j < nums.length; j++) {
            if (nums[j] == target - nums[i]) {
                return new int[] { i, j };
            }
        }
    }
    throw
new IllegalArgumentException("No two sum solution"); }

*Time complexity : O(n2
)
Space complexity : O(1
)*

大鳥解法

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        map.put(nums[i], i);
    }
    for
(int i = 0; i < nums.length; i++) { int complement = target - nums[i]; if (map.containsKey(complement) && map.get(complement) != i) { return new int[] { i, map.get(complement) }; } } throw new IllegalArgumentException("No two sum solution");

*Time complexity : O(n)
Space complexity : O(n)*

飛鷹解法

public int[] twoSum(int[] nums, int target) {
    Map<Integer, Integer> map = new HashMap<>();
    for (int i = 0; i < nums.length; i++) {
        int complement = target - nums[i];
        if (map.containsKey(complement)) {
            return new int[] { map.get(complement), i };
        }
        map.put(nums[i], i);
    }
    throw new IllegalArgumentException("No two sum solution");
}

Time complexity : O(n)
Space complexity : O(n)